<?

require_once "F_utils.php";

class C_viewnl
{
	var $nl;
	var $idx;
	var $id;
	var $idl;

	function C_viewnl($nodelist,$index)
	{
		$this->id = "!!"; $this->idl = strlen($this->id);
		if ($this->nl = @fopen($nodelist,"r")) {
			if ($this->idx = @fopen($index,"r")) {
				// All ok
			} else {
				fclose($this->nl);
			}
		}
	}

	function find_node_rec(&$tofind, $part = array(), $pos1 = 0, $level = 0)
	{
		$pos = -1;
		$result = array();

		while($pos1 > $pos) {
			$pos = $pos1;
			fseek($this->idx,$pos+$this->idl+4);
			$next = fgetint($this->idx,4);
			$bott = fgetint($this->idx,4);
			$number = fgetint($this->idx,2);
			$ok = 0;
			switch($level) {
				case 0: // zone
					$ok = $tofind[0] == $number;
					if ($ok && $tofind[2] == 0 && $tofind[3] == 0) {
						if ($tofind[1] == 0 || $tofind[1] == $tofind[0]) {
							// handle zone numbers
							return array(
								$number,false,false,false,false,false
							);
						}
					}
					break;
				case 1: // region
					$ok = 1;
					if ($tofind[1] == $number) {
						if ($tofind[2] == 0 && $tofind[3] == 0) {
							// handle regions
							return array(
								$part[0],$number,false,false,false,false
							);
						}
					}
					break;
				case 2: // net
					if ($tofind[0] == $tofind[1]) { // checking X:X/*
						$ok = $number == 65535;
					} else if ($tofind[1] == 0) { // X:0/* == X:X/*
						$ok = $number == 65535;
					} else if ($tofind[1] == $part[1]) { // X:reg/*
						$ok = $number == 65535; // found!
					} else if ($tofind[1] == $number) { // simply X:net/*
						$ok = 1;
						if ($tofind[2] == 0 && $tofind[3] == 0) {
							// handle networks
							return array(
								$part[0],$part[1],$number,false,false,false
							);
						}
					}
					break;
				case 3: // hub: ok, X:Y is checked
					$ok = 1;
					if ($tofind[3] == 0 && $tofind[2] == $number) {
						// handle hubs
						return array(
							$part[0],$part[1],$part[2],$number,false,false
						);
					}
					break;
				case 4: // node
					if ($tofind[2] == $part[3]) { // X:Y/hub
						$ok = $number == 65535;
					} else if ($tofind[2] == $number) { // X:Y/node
						$ok = 1;
						if ($tofind[3] == 0) {
							return array(
								$part[0],$part[1],$part[2],
								$part[3],$number,false
							);
						}
					}
					break;
				case 5: // oh, it is point...
					if ($tofind[3] == $number) {
						// simply X:Y/Z.P situation
						return array(
							$part[0],$part[1],$part[2],
							$part[3],$part[4],$number
						);
					}
			}
			if ($ok) {
				$part1 = $part;
				$part1[$level] = $number;
				if (($res = $this->find_node_rec(
						$tofind,
						$part1,
						$bott,
						$level+1
					)) !== false) {
					return $res;
				}
			}
			$pos1 = $next;
		}
		
		return false;
	}

	function find_node($address, $pos = 0, $level = 0)
	{
		// Return value: array of
		//  (zone, reg, net, hub, node, point)
		//  some not exists parts equal to -1
		//  some unused is false

		if (!is_array($address)) {
			if (preg_match("/^(\d+):(\d+)\/(\d+)(\.(\d+))?$/",$address,$match)) {
				$address = array($match[1],$match[2],$match[3],
					isset($match[5])?$match[5]:0);
			} else {
				return false;
			}
		}
		fseek($this->idx,$pos+$this->idl+8);
		$pos = fgetint($this->idx,4);

		return $this->find_node_rec($address,array(),$pos,0);
	}

	function get_sub_list($where = 0)
	{
		fseek($this->idx,$where+$this->idl+8);
		$pos = -1;
		$pos1 = fgetint($this->idx,4);
		$result = array();

		while($pos1 > $pos) {
			$pos = $pos1;
			fseek($this->idx,$pos+$this->idl+4);
			$next = fgetint($this->idx,4);
			fread($this->idx,4);
			$number = fgetint($this->idx,2);
			$nlpos = fgetint($this->idx,4);
			$result[] = array($number,$pos,$nlpos);
			$pos1 = $next;
		}
		
		return $result;
	}

	function get_node_record($where = 0)
	{
		fseek($this->idx,$where+$this->idl);
		$top = fgetint($this->idx,4);
		$next = fgetint($this->idx,4);
		$bott = fgetint($this->idx,4);
		$number = fgetint($this->idx,2);
		$nlpos = fgetint($this->idx,4);
		return array($top,$next,$bott,$number,$nlpos);
	}	

	function get_stats($where = 0)
	{
		fseek($this->idx,$where+$this->idl+18);
		$cnt = fgetint($this->idx,1);
		$result = array();
		for($i=$cnt/3;$i>0;$i--) {
			$result[fgetint($this->idx,1)] = fgetint($this->idx,2);
		}
		return $result;
	}

	function get_nl_line($where)
	{
		fseek($this->nl,$where,0);
		return fgets($this->nl,10240);
	}

	function seek_to_addr($addr,$where = false)
	{
		// $addr: array of
		//  (zone, reg, net, hub, node, point)
		//  some not exists parts equal to -1
		//  some unused is false
		//
		// Return value - seek in idx file

		if ($where === false) {
			if ($addr === false) return false;
			$next_value = 65535;
			$where = 0;
			while ((sizeof($addr) > 0) && ($addr[sizeof($addr)-1] === false)) {
				array_pop($addr);
			}
			if (sizeof($addr) == 0) {
				return $where;
			}
		} else {
			$next_value = array_shift($addr);
			if ($next_value === false) $next_value = 65535;
		}

		$pos = -1;
		$pos1 = $where;
		
		while($pos1 > $pos) {
			$pos = $pos1;
			fseek($this->idx,$pos+$this->idl+4);
			$next = fgetint($this->idx,4);
			$bott = fgetint($this->idx,4);
			$number = fgetint($this->idx,2);
//			print "*($pos)* $number cmp $next_value (gonna to ".dechex($bott).")\n";
			$nlpos = fgetint($this->idx,4);
			if ($number == $next_value) {
				if (sizeof($addr) == 0) {
//				print " %%% ".dechex($pos)."\n";
					return $pos;
				} else {
					return $this->seek_to_addr($addr,$bott);
				}
			}
			$pos1 = $next;
//			print "/\/\ $pos1 $pos\n";
		}
		
		return false;
	}
}

?>
